/*
 * isdrush - load YAT pictures (SCSI Direct Read)
 *   Copyright (C)1999 Tachibana Eriko
 */

#include <sys/iocs.h>

#include "isd_header.h"
#include "sdr.h"


/* External functions */
extern void yat_sub (char* buf);


/* Function */
int
sdr_yat (SDR* sdr, int frame_num, int* tbl_ptr, char* buf)
{
  int* tbl_end = tbl_ptr + frame_num;

  while (tbl_ptr < tbl_end)
    {
      int frame_size = *tbl_ptr++;

      if (SDRread (sdr, buf, frame_size) != frame_size)
	break;

#ifdef HAVE_YAT_BIN
      yat_sub (buf);
#endif

      if (*(short*)0x812 && _iocs_b_keysns () && (_iocs_b_keyinp () & 0xff) == 0x1b)
	return _iocs_b_sftsns () & 1;	/* ESC ĂI */
    }

  return 0;
}

#ifdef HAVE_YAT_BIN
__asm ("_yat_sub:\n\t"
	"movea.l (4,sp),a0\n\t"
	"movem.l d3-d7/a3-a6,-(sp)\n\t"
	".xref yat_sub\n\t"
	"bsr yat_sub\n\t"
	"movem.l (sp)+,d3-d7/a3-a6\n\t"
	"rts\n\t");
#endif

/* EOF */
